summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJonas Smedegaard <dr@jones.dk>2017-04-27 21:17:03 +0200
committerJonas Smedegaard <dr@jones.dk>2017-04-27 21:17:03 +0200
commit8db8e07720e182ef4cadf37c950819411f63f5ed (patch)
tree70f997c3dc9c36523235c9b02350bad29552bd9d
parent8895e721cd846ace93a8816c8edcdb5aa8f372d1 (diff)
Fork captureIIDC+edit+encode+stream as captureDVCAM+edit+encode+stream.
-rwxr-xr-xbin/captureDVCAM+edit+encode+stream46
1 files changed, 46 insertions, 0 deletions
diff --git a/bin/captureDVCAM+edit+encode+stream b/bin/captureDVCAM+edit+encode+stream
new file mode 100755
index 0000000..fd143c2
--- /dev/null
+++ b/bin/captureDVCAM+edit+encode+stream
@@ -0,0 +1,46 @@
+#!/bin/sh
+
+set -e
+
+AINPUT=hw:0
+VINPUT=/dev/fw1
+LOGO=../../content/icon_small.png
+
+HOST=${1:-morla}
+if [ "$HOST" = "$(hostname --short)" ]; then
+ IP=127.0.0.1
+else
+ IP=$(host "$HOST" | grep -Po 'address \K\S+')
+fi
+
+FIRSTPORT=${2:-5002} # even number - next 3 ports used too
+
+ACHANNELS=2
+AFRAMERATE=48000
+ABITRATE=32000
+
+HEIGHT=360
+VBITRATE=256000
+
+# based on http://www.webmproject.org/docs/encoder-parameters/#real-time-cbr-encoding-and-streaming
+# + scale+watermark trick based on http://stackoverflow.com/a/10937357
+# + Add 1s latency (deadline)
+# + Use same RTP payload types as GStreamer
+ffmpeg -hide_banner -threads auto -re \
+ -f alsa -sample_rate "$AFRAMERATE" -channels "$ACHANNELS" -thread_queue_size 1024 -i "$AINPUT" \
+ -f libdc1394 -video_size 640x480 -framerate 15 -thread_queue_size 256 -i "$VINPUT" \
+ -i "$LOGO" \
+ -filter_complex \
+ "[1:v]scale=-1:$HEIGHT[bg];
+ [bg][2:v]overlay=main_w-overlay_w-20:main_h-overlay_h-20[v]" \
+ -map '0:a' \
+ -codec:a libopus -ac "$ACHANNELS" -ar "$AFRAMERATE" -b:a "$ABITRATE" \
+ -f rtp -payload_type 111 "rtp://$IP:$FIRSTPORT?pkt_size=1200" \
+ -map '[v]' \
+ -pix_fmt yuv420p \
+ -codec:v vp8 -quality realtime -deadline 1000000 -cpu-used 15 \
+ -b:v "$VBITRATE" -minrate "$VBITRATE" -maxrate "$VBITRATE" \
+ -undershoot-pct 95 -bufsize $((6000*VBITRATE/1000)) -rc_init_occupancy $((4000*VBITRATE/1000)) \
+ -max-intra-rate 0 \
+ -qmin 4 -qmax 56 \
+ -f rtp -payload_type 100 "rtp://$IP:$((FIRSTPORT+2))?pkt_size=1200"